#include "pvm3.h"
#include "stdio.h"
#include "sys/timeb.h"

int main(int argc, char* argv[] ){
    if (argc!=3) {
	fprintf(stderr,"A parameterek ezek legyenek: \n\t1. melyik szamig szamoljak gyokot\n\t2. milyen pontossaggal\n");
        pvm_exit();
    }
    else {
	int adatok_szama = atoi(argv[1]);
	int szolga_szam = atoi(argv[2]);
        int sajat_tid = pvm_mytid();
        int tids[szolga_szam + 2];
        double eredmeny[adatok_szama];
        int counter, i;
        double x, x_root;
	struct timeb kezdes;
	struct timeb vegzes;
        long eltelt;
	short milisec;

        printf("\n1-tol %d-ig kiszamolom az egesz szamok gyoket.", adatok_szama);

        ftime(&kezdes);

        pvm_spawn("szolga", 0, PvmTaskDefault, "", szolga_szam, &tids[1]);

        tids[0] = tids[szolga_szam + 1] = sajat_tid;

        for(i = 1; i <= szolga_szam; ++i) {
	    pvm_initsend(PvmDataDefault);
	    pvm_pkint( &tids[i-1], 3, 1 );
	    pvm_send(tids[i], 1);
	    pvm_pkint( &adatok_szama, 1, 1 );
	    pvm_send(tids[i], 1);
        }

        for(counter = 1; counter <= adatok_szama; counter++ ) {
    	    pvm_initsend(PvmDataDefault);
	    x = counter * 1.0;
	    x_root = counter/2.0;
	    pvm_pkdouble(&x,1,1);
	    pvm_pkdouble(&x_root,1,1);
	    pvm_send(tids[1], 3);
        }

        for( i = 0; i < adatok_szama; i++) {
	    pvm_recv(tids[szolga_szam], 3);
            pvm_upkdouble(&x,1,1);
            pvm_upkdouble(&x_root,1,1);
            eredmeny[i] = x_root;
	}

//        stoptime = time(NULL);
	ftime(&vegzes);

        for( i = 1; i <= adatok_szama; i++)
	    printf("\n %d gyoke =  %f", i, eredmeny[i-1]);

        eltelt=vegzes.time-kezdes.time;
	if (vegzes.millitm<kezdes.millitm) {
	    eltelt--;
	    milisec=kezdes.millitm-vegzes.millitm;
	}
	else {
	    milisec=vegzes.millitm-kezdes.millitm;
	}

	printf("\n\n Futasi ido: %ld.%03u\n", eltelt, milisec);

        pvm_exit();
    }
    return 0;
}
